Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 export GIT_AUTHOR_NAME="Flan Hacker"
18 export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 export GOT_AUTHOR_8="flan_hac"
23 export GOT_LOG_DEFAULT_LIMIT=0
25 export MALLOC_OPTIONS=S
27 function git_init
28 {
29 git init -q "$1"
30 }
32 function git_commit
33 {
34 local repo="$1"
35 shift
36 (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
37 }
39 function git_rm
40 {
41 local repo="$1"
42 shift
43 (cd $repo && git rm -q "$@")
44 }
46 function git_show_head
47 {
48 local repo="$1"
49 (cd $repo && git show --no-patch --pretty='format:%H')
50 }
52 function git_show_author_time
53 {
54 local repo="$1"
55 local object="$2"
56 (cd $repo && git show --no-patch --pretty='format:%at' $object)
57 }
59 function git_show_parent_commit
60 {
61 local repo="$1"
62 (cd $repo && git show --no-patch --pretty='format:%P')
63 }
65 function git_show_tree
66 {
67 local repo="$1"
68 (cd $repo && git show --no-patch --pretty='format:%T')
69 }
71 function trim_obj_id
72 {
73 let trimcount=$1
74 id=$2
76 pat=""
77 while [ trimcount -gt 0 ]; do
78 pat="[0-9a-f]$pat"
79 let trimcount--
80 done
82 echo ${id%$pat}
83 }
85 function git_commit_tree
86 {
87 local repo="$1"
88 local msg="$2"
89 local tree="$3"
90 (cd $repo && git commit-tree -m "$msg" "$tree")
91 }
93 function make_test_tree
94 {
95 repo="$1"
97 echo alpha > $repo/alpha
98 echo beta > $repo/beta
99 mkdir $repo/gamma
100 echo delta > $repo/gamma/delta
101 mkdir $repo/epsilon
102 echo zeta > $repo/epsilon/zeta
105 function get_blob_id
107 repo="$1"
108 tree_path="$2"
109 filename="$3"
111 got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
114 function test_init
116 local testname="$1"
117 local no_tree="$2"
118 if [ -z "$testname" ]; then
119 echo "No test name provided" >&2
120 return 1
121 fi
122 local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
123 mkdir $testroot/repo
124 git_init $testroot/repo
125 if [ -z "$no_tree" ]; then
126 make_test_tree $testroot/repo
127 (cd $repo && git add .)
128 git_commit $testroot/repo -m "adding the test tree"
129 fi
130 echo "$testroot"
133 function test_cleanup
135 local testroot="$1"
137 (cd $testroot/repo && git fsck --strict \
138 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
139 ret="$?"
140 if [ "$ret" != "0" ]; then
141 echo -n "git fsck: "
142 cat $testroot/fsck.stderr
143 echo "git fsck failed; leaving test data in $testroot"
144 return 1
145 fi
147 rm -rf "$testroot"
150 function run_test
152 testfunc="$1"
153 echo -n "$testfunc "
154 $testfunc
157 function test_done
159 local testroot="$1"
160 local result="$2"
161 if [ "$result" == "0" ]; then
162 test_cleanup "$testroot" || return 1
163 echo "ok"
164 elif echo "$result" | grep -q "^xfail"; then
165 # expected test failure; test reproduces an unfixed bug
166 echo "$result"
167 test_cleanup "$testroot" || return 1
168 else
169 echo "test failed; leaving test data in $testroot"
170 fi